// onat.cpp: ejercicio #1
// Fecha: 16/11/2020; 5 pm
#include "onat.h"
#include <iostream>

bool mayorQue( const Entidad & e1, const Entidad & e2 ) {
    if ( e1.getImp() > e2.getImp() ) return true;
    return false;
}

// ENTIDAD

Entidad::Entidad( Str nom, double gan )
    : nombre( nom ), ganancia( gan ), impuesto( 0 ) {}

// datos para calcular los impuestos:
//  los impuestos
const float IMP1 = 0.1;
const float IMP2 = 0.15;
const float IMP3 = 0.2;

//  los lmites
const int LIM5  = 5000;
const int LIM10 = 10000;
const int LIM20 = 20000;

void Entidad::calcImp() {
    //  las variables
    float neto1, neto2, neto3; // a deducir
    float gana;

    if( ganancia <= LIM5 ) {
        setImp( 0 );
    } else if( ganancia > LIM5 and ganancia <= LIM10 ) {
        gana = ganancia - LIM5; // lo que sobra
        setImp( gana * IMP1 );  // impuesto por lo sobrante
    } else if( ganancia > LIM10 and ganancia <= LIM20 ) {
        gana = ganancia - ( LIM5 + LIM10 ); // lo que sobra
        neto1 = LIM10 * IMP1;               // impuesto por 10,000
        neto2 = gana  * IMP2;               // impuesto por lo sobrante
        setImp( neto1 + neto2 );
    } else {
        gana = ganancia - ( LIM5 + LIM10 + LIM20 ); // lo que sobra
        neto1 = LIM10 * IMP1;                       // impuesto por 10,000
        neto2 = LIM20 * IMP2;                       // impuesto por 20,000
        neto3 = gana  * IMP3;                       // impuesto por lo sobrante
        setImp( neto1 + neto2 + neto3 );
    } // if-en-cascada
}

#include <ios>
#include <iomanip>

void Entidad::mostrar( std::ostream & os ) const {
    os << std::left  << std::setw( 30 ) << getNom()
       << std::right << std::setw( 15 ) << getGan()
       << std::setw( 15 ) << getImp() << '\n';
}

// ONAT

// asume que el record est
double Onat::getImp( Str nom ) const {
    for ( auto x: item )
        if ( nom == x.getNom() )
            return x.getImp();
}

#include <algorithm>
#include <ctime>

void Onat::mostrar( std::ostream & os ) {
    time_t laFecha;
    time( &laFecha );
    std::ios::fmtflags oldFlags = os.flags();
    os << "\nEl Reino del Reves - Sistema de Impuestos.\n"
       << ctime( &laFecha ) << std::setfill( ' ' )
       << std::left  << std::setw( 30 )   << "Nombre"
       << std::right << std::setw( 15 )   << "Gan\242"
       << std::setw( 16 ) << "Impuesto\n" << std::fixed
       << std::setprecision( 2 ) << std::setfill( '.' );

    item.sort( mayorQue );

    for ( auto x: item )
        x.mostrar( os );

    os << '\n';
    os.flags( oldFlags );
}

#include <iostream>

void Onat::entrar() {
    using std::cout;
    using std::cin;
    Str nomb;
    double gano;
    Entidad entd;

    cout << "\nNombre: ";
    std::getline( cin, nomb );
    cout << "Ganancia anual: ";
    cin >> gano;
    entd.setNom( nomb );
    entd.setGan( gano );
    entd.calcImp();
    item.push_back( entd );

    cout << HECHO;
}

// asume una BD no vaca
bool Onat::yaEsta( Str nom ) const {
    for ( auto x: item )
        if ( nom == x.getNom() )
            return true;
    return false;
}

// asume una BD no vaca
// asume que el registro ya est
void Onat::borrar( Str nom ) {
    Item::iterator i = item.begin();

    for ( auto x: item ) {
        if ( nom == x.getNom() ) {
            item.erase(i);
            return;
        }

        ++i;
    }
}
