// Problema 8: una plantilla functor
// Fecha: 15/10/2020; 10 am
// S. Galliano.

#include "estads.h"
#include <iostream>
#include <cstdlib>
#include <list>
#include <fstream>
#include <algorithm>
#include <iomanip>

int main() {
    using namespace std;
    cout << "Ejercicio 8: una plantilla functor.\n\n";
    cout << "Para una lista de enteros:\n";
    std::ifstream leerI( "C://temp//datos.txt" );

    if ( leerI.fail() ) {
        std::cerr << "Fallo de lectura. Abortando.\n";
        return EXIT_FAILURE;
    }

    int val1;
    std::list<int> lInt;

    while ( leerI >> val1 )
        lInt.push_back(val1);

    leerI.close();

    Estads<int> stI = for_each( lInt.begin(), lInt.end(), Estads<int>(lInt) );
    cout << std::setprecision( 4 ) << std::fixed;
    cout << "Media   = " << std::setw( 9 ) << stI.media()   << '\n';
    cout << "Mediana = " << std::setw( 9 ) << stI.mediana() << '\n';
    cout << "Moda    = " << std::setw( 4 ) << stI.moda()    << '\n';
    cout << "Varz.   = " << std::setw( 9 ) << stI.varza()   << '\n';
    cout << "Desviac.= " << std::setw( 9 ) << sqrt( stI.varza() ) << '\n';
    cout << "M\240ximo  = " << std::setw( 4 ) << stI.Max()  << '\n';
    cout << "M\241nimo  = " << std::setw( 4 ) << stI.Min()  << '\n';
    cout << "Rango   = " << std::setw( 4 ) << stI.Max() - stI.Min() << '\n';
    cout << "Suma    = " << std::setw( 4 ) << stI.suma()    << '\n';
    cout << "Cuenta  = " << std::setw( 4 ) << stI.cuenta()  << "\n\n";

    cout << "Para un vector de reales:\n";
    std::ifstream leerD( "C://temp//gauss.txt" );

    if ( leerD.fail() ) {
        std::cerr << "Fallo de lectura. Abortando.\n";
        return EXIT_FAILURE;
    }

    double val2;
    std::vector<double> vDbl;

    while ( leerD >> val2 )
        vDbl.push_back(val2);

    leerD.close();

    Estads<double> stD = for_each( vDbl.begin(), vDbl.end(), Estads<double>(vDbl) );
    cout << std::setprecision( 4 ) << std::fixed;
    cout << "Media   = " << std::setw( 9 ) << stD.media()   << '\n';
    cout << "Mediana = " << std::setw( 9 ) << stD.mediana() << '\n';

    INFINITY == stD.moda()
        ?cout << "Moda    =  N/A\n"
        :cout << "Moda    = " << std::setw( 4 ) << stD.moda()    << '\n';

    cout << "Varz.   = " << std::setw( 9 ) << stD.varza()   << '\n';
    cout << "Desviac.= " << std::setw( 9 ) << sqrt( stD.varza() ) << '\n';
    cout << "M\240ximo  = " << std::setw( 9 ) << stD.Max()  << '\n';
    cout << "M\241nimo  = " << std::setw( 9 ) << stD.Min()  << '\n';
    cout << "Rango   = " << std::setw( 9 ) << stD.Max() - stD.Min() << '\n';
    cout << "Suma    = " << std::setw( 9 ) << stD.suma()    << '\n';
    cout << "Cuenta  = " << std::setw( 4 ) << stD.cuenta()  << "\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
