#ifndef MI_LISTA_H_INCLUDED
#define MI_LISTA_H_INCLUDED

// mi_lista.h: declaraciones para el ejercicio 12
// Fecha: 2/11/2020; 6:11 pm

#include <iostream>
#include <algorithm>
#include <deque>
#include <vector>
#include <list>
#include <iterator>

template <typename T> class LSE {
public:
    LSE( std::list<T>   &l ) { coll.assign( l.begin(), l.end() ); }
    LSE( std::vector<T> &v ) { coll.assign( v.begin(), v.end() ); }
    LSE( std::deque<T>  &d ) : coll( d ) {}

    // accesores
    std::deque<T> getColl() const { return coll; }
    // mtodos
    void entra( T valor );
    bool estaVacia() const { return 0 == coll.size(); }
    bool enLista( T valor ) const;
    bool borra( T valor );
    int  cuenta() const { return coll.size(); }
    void muestraColl() const;
    void vaciaColl() { coll.clear(); }
    void ordena();
private:
    std::deque<T> coll; //  miembro
};

template <typename T> void LSE<T>::entra( T valor) { coll.push_back( valor ); }

template <typename T> bool LSE<T>::enLista( T valor ) const {
    for ( auto x: coll ) {
        if ( valor == x ) {
            return true;
        } // if;
    } // for-en-rangos

    return false;
}

template <typename T> bool LSE<T>::borra( T valor ) {
    if ( enLista( valor ) ) {
        typename std::deque<T>::iterator i = coll.begin();

        for ( auto x : coll ) {
            if ( valor == x ) {
                coll.erase( i );
                return true;
            } // if;

            ++i;
        } // for-en-rangos
    }

    return false;
}

template <typename T> void LSE<T>::muestraColl() const {
   for ( auto x: coll ) {
       std::cout << x << ", ";
   } // for-en-rangos

   std::cout << "\b\b \n";
}

template <typename T> void LSE<T>::ordena() { sort( coll.begin(), coll.end() ); }

#endif // MI_LISTA_H_INCLUDED
