// muestreo.h: ejercicio 15, muestreo MAS
// Fecha: 11/10/2020; 10:10 am
#include "muestreo.h"
#include "../../Programas/deposito/rnd.h"
#include <iostream>
using std::cout;

//  funciones auxiliares:

//  genera un punto de entrada al archivo de valores
double generaVals() {
    // generador Mersenne Twister de nmeros aleatorios
    // con una semilla derivada de rand()
    std::mt19937 mt(rand());

    // crea una distribucin uniforme de enteros
    // Dado un generador de nmeros, producir
    // uno en el rango (0:M)
    //std::uniform_real_distribution<double>dist( 0, POBLACN );
    std::normal_distribution<double>dist(0, 1);

    // un nmero al azar a partir del valor
    // mximo que puede alcanzar una muestra
    return dist(mt);
}

//  genera valores y los pone en el vector poblacin
//  input: nada
//  output: los valores estn en el vector
void MAS::generaPob() {
    for ( int i = 0; i < POBLACN; ++i )
        pob.push_back(generaVals());
}

//  toma valores de la poblacin y
//  los pone en el vector muestra
//  input: valores del vector poblacin
//  output: los valores estn en la muestra
void MAS::generaMst() {
    for ( int i = 0, idx = 0; i < MUESTRA; ++i, idx += 2 )
        mst.push_back( pob[idx]);
}

#include "../../Programas/deposito/estads.h"
#include <iomanip>

//  imprime los valores usando un functor
//  input: un vector
//  output: sus estadsticos a consola
void MAS::impreVals( Vct vct ) {
    Estads<double> stD = for_each( vct.begin(), vct.end(), Estads<double>(vct) );
    cout << std::setprecision( 4 ) << std::fixed;
    double vrz = stD.varza();
    cout << "Media = " << stD.media() << '\n';
    cout << "Varz. = " << vrz         << '\n';
    cout << "Desv. = " << sqrt( vrz ) << '\n';
    cout << "Cant. = " << stD.cuent() << '\n';
}
