#ifndef PRODUCTO_H_INCLUDED
#define PRODUCTO_H_INCLUDED

//  producto.h: definiciones para el programa 1
//  Fecha: 29/6/2020; 8:32 am
//  Revisin: 15/9/2020; 2:15 pm
//  Por: S. Galliano.

#include <string>
typedef std::string Str;
#include <fstream>

namespace misNombres {

/**
@brief Maneja un producto alimentario.
@param <b>nombre</b> del producto.
@param <b>costo</b> del producto.
@param <b>venta</b> del producto.
@param <b>cantidad</b>del producto.
S. Galliano. 1/7/2020; 8:45 pm
*/

class Producto {
public:
    // constructor
    Producto( Str nb = "", float co = 0, float ve = 0, int ct = 0 );
    // accesores de entrada
    void setNombre( Str valor );
    void setCantidad( int valor );
    // accesores de salida
    Str   getNombre()   const;
    float getCosto()    const;
    float getVenta()    const;
    int   getCantidad() const;
    // otros miembros
    void muestra( std::ostream & escribe ) const;
private:
    Str nombre;
    float costo;
    float venta;
    int cantidad;
};

} // misNombres

#endif // PRODUCTO_H_INCLUDED
