//  entidad.cpp: definiciones para el programa 2
//  Fecha: 30/6/2020; 7:43 pm
//  Por: S. Galliano.
#include "entidad.h"
#include <iostream>
#include <iomanip>
#include <cmath>

using std::cout;
using std::cin;
using std::setw;

namespace misNombres {
Entidad::Entidad( bool valor ) : listo( valor ), recaudo( 0 ) {
    listado.clear();
    cargarLista();
}

void  Entidad::setBool( bool  valor ) { listo = valor; }
void  Entidad::setReca( float valor ) { recaudo = valor; }
bool  Entidad::getBool() const { return listo; }
float Entidad::getReca() const { return recaudo; }

void Entidad::cargarLista() {
    Producto // primero cargar las estructuras
    p1( "Rollito",  .73, 1   ),
    p2( "Refresco", .57, 1.2 ),
    p3( "Helado",   .49,  .75 );
    // luego entrarlas en la lista
    listado.push_back( p1 );
    listado.push_back( p2 );
    listado.push_back( p3 );
}

void Entidad::muestraMenu() {
    Producto tmp;
    cout << "Hay " << listado.size() << " productos en el men\243.\n\n"
         << std::setprecision( 2 ) << std::fixed
         << std::left  << setw( 10 ) << "Oferta"
         << std::right << setw( 10 ) << "Precio$\n";

    for ( auto x: listado ) {
        cout << std::left  << setw( 10 ) << x.getNombre()
             << std::right << setw( 8 )  << x.getVenta() << '\n';
    } // for

    cout << '\n';
}

float Entidad::tomaVentas() {
    Producto tmp;
    float cant, total = 0;
    cout << "Entrando las cantidades vendidas.\n\n";

    for ( unsigned i = 0; i != listado.size(); ++i ) {
        cout << listado[i].getNombre() << ": ";
        cin >> cant;
        listado[i].setCantidad( cant );
        total += listado[i].getCantidad() * listado[i].getVenta();
    } // for

    cout << '\n';
    return total;
}

void Entidad::muestraRecaudo( float valor ) {
    cout << "\nTotal ventas del d\241a:\n\n"
         << std::setprecision( 2 ) << std::fixed << std::left
         << setw( 10 ) << "Oferta" << std::right
         << setw( 10 ) << "Cant."
         << setw( 10 ) << "Precio"
         << setw( 10 ) << "Venta"  << '\n';

    for ( auto x: listado ) {
        cout << std::left
             << setw( 10 ) << x.getNombre() << std::right
             << setw( 10 ) << x.getCantidad()
             << setw( 10 ) << x.getVenta()
             << setw( 10 ) << x.getCantidad() * x.getVenta() << '\n';
    } // for

    cout << std::right << "Total " << std::setfill( '.' ) << setw( 34 ) << valor << "$\n\n";
}

} // misNombres
