#ifndef ENTIDAD_H_INCLUDED
#define ENTIDAD_H_INCLUDED

//  entidad.h: definiciones para el programa 2
//  Fecha: 30/6/2020; 7:43 pm
//  Por: S. Galliano.

#include <string>
#include <vector>
#include "../prob01-productos/producto.h" // <-- requerido

typedef std::vector<misNombres::Producto> Lst;
const std::string ERROR( "Tomar ventas primero.\n\n" );

namespace misNombres {
/**
@brief Maneja una entidad de venta.
@param <b>recaudo</b> del producto.
@param <b>listo</b> si ya puede reportar.
@param <b>lst</b> listado de los productos.
S. Galliano. 1/7/2020; 8:45 pm
*/
class Entidad {
public:
    Entidad( bool valor = false ); // constructor
    // accesores
    void  setBool( bool  valor );
    void  setReca( float valor );
    bool  getBool() const;
    float getReca() const;
    // mtodos
    void  cargarLista();
    void  muestraMenu();
    float tomaVentas();
    void  muestraRecaudo( float valor );
private:
    double recaudo;
    bool listo;
    Lst listado;
};

} // misNombres

#endif // ENTIDAD_H_INCLUDED
