//  crono.cpp: definiciones para el problema 3
//  Fecha: 13/10/2019; 8:07 am
//  Revisin: 15/9/2020; 8:26 am
//  versin sobre Halterman, 16.2-STOPWATCH, pg. 477

#include "crono.h"
#include <iostream>

// Crea un Crono
// comienza en cero, no est corriendo y no ha medido nada
Crono::Crono(): comienzo( 0 ), contando( false ), transcurrido( 0 ) {}

// arranca el crono y comienza a contar;
// se ignora si se intenta arrancar uno que ya arranc,
void Crono::start() {
    if ( not contando ) {
        contando = true;
        comienzo = clock();
    } // if
}

// detiene el crono y acumula el tiempo contado,
// si est parado, se ignora la peticin
void Crono::stop() {
    if ( contando ) {
        contando = false;
        clock_t fin = clock();
        transcurrido += static_cast<double>( fin - comienzo ) / CLOCKS_PER_SEC;
    } // if
}

// devuelve el estado interno del cronmetro
// (si est contando o no), pero no lo afecta.
bool Crono::estaContando() const {
    return contando;
}

// relanza el crongrafo para volver a medir tiempo,
// si est contando, lo detiene
void Crono::reset() {
    contando = false;
    transcurrido = 0;
}

// informa el tiempo que se ha medido en s;
// no afecta el estado interno del crono.
double Crono::reportar() {
    double resp;

    if ( contando ) {
        clock_t actual = clock();
        resp = static_cast<double>( actual - comienzo ) / CLOCKS_PER_SEC;
        resp += transcurrido;
        // si estaba parado, el tiempo ya est marcado en stop()
    } else {
        resp = transcurrido;
    } // if-else

    return resp;
}
