#ifndef VECTORES_H_INCLUDED
#define VECTORES_H_INCLUDED

//  vectores.h: definiciones para el programa 4
//  Fecha: 25/7/2020; 11 am
//  Revisión: 14/11/2020; 12:50 pm
//  Por: S. Galliano.

#include <string>
#include <cmath>

namespace miVector { // <--
const double GRAD2RAD = 45.0 / atan( 1.0 ); // ‪57.29578‬...
enum Modo { Polar, Cartesiano };

class Vector {
public:
    // constructor
    Vector( double a = 0, double b = 0 );
    // accesores
    bool getModo() const { return modo == Cartesiano; }
    void setValX( double valor ) { x = valor; }
    void setValY( double valor ) { y = valor; }
    // operadores sobrecargados
    Vector operator+( Vector & b ) const; // suma A + B
    Vector operator-( Vector & b ) const; // diferencia A - B
    Vector operator-()             const; // cambio de signo -A
    Vector operator*( double n )   const; // producto nA
    void   operator=( Modo valor );       // asignación del modo
    // amigas, al final de la parte pública
    friend Vector operator*( double n, const Vector & a );         // producto An
    friend double operator*( const Vector & a, const Vector & b ); // producto A.B
    friend double coseno( Vector & a, Vector & b );                // coseno <A,B>
    friend double modulo( const Vector & v );                      // módulo del vector
    friend double angulo( const Vector & v );                      // ángulo del vector
    // operadores de E/S
    friend std::ostream & operator<<( std::ostream & os, const Vector & v );
    friend std::istream & operator>>( std::istream & is, Vector & v );
private:
    //  miembros
    double x, y; // sus dos coordenadas
    Modo modo;   // estado del vector
};
} // namespace miVector <--

#endif // VECTORES_H_INCLUDED
