#ifndef PLANTILLA_H_INCLUDED
#define PLANTILLA_H_INCLUDED

// plantilla.h: minimax
// Fecha: 29/9/2020; 8:23 pm

#include <vector>
#include <list>
#include <deque>
#include <algorithm>

template <typename T> class MiniMax {
public:
    MiniMax( std::vector<T> &vct ) { v.assign( vct.begin(), vct.end() ); }
    MiniMax( std::list<T>   &lst ) { v.assign( lst.begin(), lst.end() ); }
    MiniMax( std::deque<T>  &dek ) { v.assign( dek.begin(), dek.end() ); }
    std::pair<T, T> buscar();
private:
    std::vector<T> v;
    T min_;
    T max_;
};

template<typename T> std::pair<T, T> MiniMax<T>::buscar() {
    min_ = *min_element( v.begin(), v.end() );
    max_ = *max_element( v.begin(), v.end() );
    return std::make_pair( min_, max_ );
}

#endif // PLANTILLA_H_INCLUDED
