// Programa 8: una plantilla functor
// Fecha: 1/10/2020; 1:50 pm
// Revisin: 3/10/2020; 5 pm
// S. Galliano

#include "estads.h"
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <iomanip>

int main() {
    using std::cout;
    std::cout << "Programa 14: functores.\n\n";

    cout << "Para una lista de enteros:\n";
    std::ifstream leeEntero( "C://temp//datos.txt" );

    if ( leeEntero.fail() ) {
        std::cerr << "Fallo de lectura. Abortando.\n";
        return EXIT_FAILURE;
    }

    std::list<int> lInt;
    int valor1;

    while ( leeEntero >> valor1 )
        lInt.push_back(valor1);

    Estads<int> stI = for_each( lInt.begin(), lInt.end(), Estads<int>(lInt) );
    cout << "Media   = " << stI.media() << '\n';
    cout << "Mediana = " << stI.medin() << '\n';
    cout << "Varz.   = " << stI.varza() << '\n';
    cout << "Suma    = " << stI.suma()  << '\n';
    cout << "Cant.   = " << stI.cuent() << "\n\n";

    cout << "Para un vector de reales:\n";
    std::ifstream leeDoble( "C://temp//gauss.txt" );

    if ( leeDoble.fail() ) {
        std::cerr << "Fallo de lectura. Abortando.\n";
        return EXIT_FAILURE;
    }

    std::vector<double> vDbl;
    double valor2;

    while ( leeDoble >> valor2 )
        vDbl.push_back(valor2);

    Estads<double> stD = for_each( vDbl.begin(), vDbl.end(), Estads<double>(vDbl) );
    cout << std::setprecision( 4 ) << std::fixed;
    cout << "Media   = " << stD.media() << '\n';
    cout << "Mediana = " << stD.medin() << '\n';
    cout << "Varz.   = " << stD.varza() << '\n';
    cout << "Suma    = " << stD.suma()  << '\n';
    cout << "Cant.   = " << stD.cuent() << "\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
